const MOZCELLMLUISERVICE_CONTRACTID = '@physiome.org/mozCellML/UIService;1';
const MOZCELLMLUISERVICE_CID = Components.ID('{33bcef6d-4602-4d9c-a633-425c4e4285fa}');

function mozCellMLUIService()
{
  this.passto = null;
  return this;
}

mozCellMLUIService.prototype =
{
  QueryInterface: function(iid)
  {
    if (iid.equals(Components.interfaces.nsISupports) ||
        iid.equals(Components.interfaces.mozICellMLUIService))
      return this;
    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  setUI: function(pt)
  {
    this.passto = pt;
  },
  
  getUI: function(pt)
  {
    return this.passto;
  },

  clearUI: function()
  {
    this.passto = null;
  },

  displayModel: function(model)
  {
    if (this.passto == null)
    {
      var ww =
        Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                  .getService(Components.interfaces.nsIWindowWatcher);
      ww.openWindow(null, "chrome://mozcellml/content/unified.xul",
                    null, "chrome,dialog=no,left=0,top=0,width=800,height=600", model);
    }
    else
      this.passto.displayModel(model);
  }
};

var mozCellMLUIServiceModule = {
  registerSelf: function(compMan, file, location, type)
  {
    compMan = compMan.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    compMan.registerFactoryLocation(
                                    MOZCELLMLUISERVICE_CID,
                                    "mozCellML User Interface Service",
                                    MOZCELLMLUISERVICE_CONTRACTID,
                                    file, location, type
                                   );
  },

  getClassObject: function(compMan, cid, iid)
  {
    if (cid.equals(MOZCELLMLUISERVICE_CID) &&
        iid.equals(Components.interfaces.nsIFactory))
      return mozCellMLUIServiceFactory;
    throw Components.results.NS_ERROR_FAILURE;
  },

  canUnload: function(compMan)
  {
    return true;
  }
};

var mozCellMLUIServiceFactory = {
  createInstance: function(outer, iid)
  {
    if (outer != null)
      throw Components.results.NS_ERROR_NO_AGGREGATION;

    if (iid.equals(Components.interfaces.nsISupports) ||
        iid.equals(Components.interfaces.mozICellMLUIService))
      return new mozCellMLUIService();

    throw Components.results.NS_ERROR_INVALID_ARG;
  }
};

function NSGetModule(comMgr, fileSpec) { return mozCellMLUIServiceModule; }
