function ChangeIntegratorButtons(d, intg, run)
{
  var expert = 0;
  try
  {
    var prefservice =
      Components.classes["@mozilla.org/preferences-service;1"]
               .getService(Components.interfaces.nsIPrefService);
    var cellBranch = prefservice.getBranch("physiome.mozcellml.");
    expert = cellBranch.getIntPref("expertlevel");
  }
  catch (e) {}

  SetVisibility(d.getElementById("compile-integrator"), !intg);
  SetVisibility(d.getElementById("kill-integrator"), intg && (expert > 1));
  SetVisibility(d.getElementById("start-integration"), (!run) && intg);
  SetVisibility(d.getElementById("cancel-integration"), run && intg);
}

function GetRDFIndexFromTree(obj, t)
{
  try
  {
    var treeidx = t.view.selection.currentIndex;
    var builder = t.view.QueryInterface(Components.interfaces.nsIXULTreeBuilder);
    var resource = builder.getResourceAtIndex(treeidx);
    var idxnode = obj.rdfsource_active.GetTarget(resource, obj.rdfindex, true);
    return idxnode.QueryInterface(Components.interfaces.nsIRDFInt).Value;
  }
  catch (e)
  {
     return -1;
  }
}

function Import(obj, name)
{
  this.obj = obj;
  this.name = name;
  return this;
}

Import.prototype = 
{
  components: [],
  compnames: [],

  addOrGetComponent: function(name)
  {
    var i;
    for (i = 0; i < this.compnames.length; i++)
      if (this.compnames[i] == name)
        return this.components[i];
    this.compnames[i] = name;

    var res = window.rdfserv.GetAnonymousResource();

    this.obj.rdfsource.Assert
    (
     res,
     window.rdfname,
     window.rdfserv.GetLiteral(name),
     true
    );

    this.components[i] = window.rdfcu.MakeSeq(this.obj.rdfsource, res);

    this.rdfcontainer.AppendElement(res);

    return this.components[i];
  }
};

function AddOrGetImport(obj, i)
{
  if (obj.imports[i] != null)
    return obj.imports[i];

  var name = window.model.describeImportNumber(i);
  obj.imports[i] = new Import(obj, name);
  var compres = window.rdfserv.GetAnonymousResource();
  obj.rdfsource.Assert(compres, window.rdfname,
                       window.rdfserv.GetLiteral(name),
                       true);

  obj.imports[i].rdfcontainer =
    window.rdfcu.MakeSeq(obj.rdfsource, compres);

  obj.rdfvarcont.AppendElement(compres);

  return obj.imports[i];
}

function ProxyToMain(object, iface)
{
    var eqs = Components.classes["@mozilla.org/event-queue-service;1"]
                              .getService(Components.interfaces.nsIEventQueueService);
    var main_thread = eqs.getSpecialEventQueue(Components.interfaces.nsIEventQueueService.UI_THREAD_EVENT_QUEUE);

    var proxyObjectManager = Components.classes["@mozilla.org/xpcomproxy;1"]
                                       .getService(Components.interfaces.nsIProxyObjectManager);

    const PROXY_SYNC = 0x01;
    const PROXY_ALWAYS = 0x04;
    return proxyObjectManager.getProxyForObject(main_thread, iface, object,
                                                PROXY_SYNC | PROXY_ALWAYS);
}
