/*	-*- C++ -*-
 * Copyright (C) 2001,  Christof Meerwald <cmeerw@web.de>
 * http://xpcom2corba.sunsite.dk/
 */

/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License
 * at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and
 * limitations under the License.
 *
 * The Original Code is the XPCOM-CORBA Bridge package.
 *
 * The Initial Developer of the Original Code is Christof Meerwald.
 * Portions created by Christof Meerwald are Copyright (C) 2001
 * Christof Meerwald.  All Rights Reserved.
 *
 * Contributor(s): Christof Meerwald <cmeerw@web.de> (original author)
 */
#ifndef HEADER__CORBA_SERVANT__INCLUDED
#define HEADER__CORBA_SERVANT__INCLUDED

#include "xpcorba_config.h"

#include <nsISupports.h>
#include <CORBA.h>


class CORBA_Proxy_Servant
  : public virtual PortableServer::ServantBase
{
 public:
  CORBA_Proxy_Servant(nsISupports *xpcom_obj);

  virtual ~CORBA_Proxy_Servant();


  virtual void add_ref();
  virtual void release_ref();

  virtual const char *_repository_id() const = 0;
  virtual const char **_operation_names() const = 0;
  virtual const char **_base_repository_ids() const = 0;
};

#endif
