/*	-*- C++ -*-
 * Copyright (C) 2001,  Christof Meerwald <cmeerw@web.de>
 * http://xpcom2corba.sunsite.dk/
 */

/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License
 * at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and
 * limitations under the License.
 *
 * The Original Code is the XPCOM-CORBA Bridge package.
 *
 * The Initial Developer of the Original Code is Christof Meerwald.
 * Portions created by Christof Meerwald are Copyright (C) 2001
 * Christof Meerwald.  All Rights Reserved.
 *
 * Contributor(s): Christof Meerwald <cmeerw@web.de> (original author)
 */
#ifndef HEADER__XPCOM_PROXY__INCLUDED
#define HEADER__XPCOM_PROXY__INCLUDED

#include "xpcorba_config.h"
#include "xpcom_object.h"

#include <nsISupports.h>
#include <CORBA.h>

#include <map>


struct nsIID_Less
{
  bool operator()(const nsIID *x, const nsIID *y) const;
};

class XPCOM_Proxy_Factory
{
 protected:
  XPCOM_Proxy_Factory(const nsIID &iid, const XPCOM_Proxy_Factory *factory);

 public:
  virtual ~XPCOM_Proxy_Factory();


  /**
   * @param ref_count is only needed for CORBA-wrapped XPCOM objects
   */
  virtual CORBA_IObject *GetProxy(CORBA::Object_ptr obj,
				  PRInt32 *ref_count) const = 0;

  static CORBA_IObject *GetProxy(const nsIID &iid,
				 CORBA::Object_ptr obj, PRInt32 *ref_count);


 private:
  typedef std::map<const nsIID *, const XPCOM_Proxy_Factory *, nsIID_Less>
    Factory_Map;

  static Factory_Map *factories_;

  Factory_Map::iterator factory_iter_;
};

#endif
